from types import ModuleType
from typing import Optional

from Cryptodome.PublicKey.RSA import RsaKey


class PKCS115_SigScheme:
    def __init__(self, rsa_key: RsaKey) -> None: ...
    def can_sign(self) -> bool: ...
    def sign(self, msg_hash: ModuleType) -> bytes: ...
    def verify(self, msg_hash: ModuleType, signature: bytes) -> None: ...

def _EMSA_PKCS1_V1_5_ENCODE(msg_hash: ModuleType, emLen: int, with_hash_parameters: Optional[bool]=True) -> bytes: ...

def new(rsa_key: RsaKey) -> PKCS115_SigScheme: ...